	; IntyBASIC compiler v0.1 Jan/28/2014
        ROMW 16
        ORG $5000
        
        ;
        ; ROM header
        ;
        BIDECLE _ZERO           ; MOB picture base
        BIDECLE _ZERO           ; Process table
        BIDECLE _MAIN           ; Program start
        BIDECLE _ZERO           ; Background base image
        BIDECLE _ONES           ; GRAM
        BIDECLE _TITLE          ; Cartridge title and date
        DECLE   $03C0           ; No ECS title, inits code after title,
                                ; ... no clicks
                                
_ZERO:  DECLE   $0000           ; Border control
        DECLE   $0000           ; 0 = color stack, 1 = f/b mode
        
_ONES:  DECLE   $0001, $0001    ; Initial color stack 0 and 1: Blue
        DECLE   $0001, $0001    ; Initial color stack 2 and 3: Blue
        DECLE   $0001           ; Initial border color: Blue

C_WHT:  EQU $0007

CLRSCR: MVII #$200,R4
        MVII #$F0,R1
FILLZERO:
        CLRR R0
MEMSET:
        MVO@ R0,R4
        DECR R1
        BNE MEMSET
        JR R5

        ;
        ; Title, avoid and jump directly into main program
        ;
_TITLE: PROC
        BYTE    114, 'IntyBASIC program', 0
;        BEGIN

;        RETURN                  ; Return to EXEC for title screen display
        ENDP

        ;
        ; Main program
        ;
_MAIN:
        DIS
        MVII    #STACK, R6

_MAIN0:
        MVII #$0fe,R1           ; 240 words of 8 bits plus 14 of sound
        MVII #$100,R4           ; 8-bit scratch RAM
        CALL FILLZERO
        MVII #$040,R1           ; 64 words of 16 bits
        MVII #$320,R4           ; 16-bit scratch RAM
        CALL FILLZERO

        CALL CLRSCR             ; Clean up screen

        MVII    #_int_vector,R0 ; Points to interrupt vector
        MVO     R0,     ISRVEC
        SWAP    R0
        MVO     R0,     ISRVEC+1
        MVII    #2,R0
        MVO R0,_first_time

        EIS
        MVII #7,R0
        MVO R0,_color
        MVII #$038,R0
        MVO R0,$01F8            ; Configures sound
	; 	rem
	; 	rem Test of Intybasic features
	; 	rem by Oscar Toledo G. http://nanochess.org
	; 	rem Jan/22/2014, last updated Jan/27/2014
	; 	rem
	; main:
	; MAIN
Q1:	; 	cls
	CALL CLRSCR
	MVII #$200,R0
	MVO R0,_screen
	; 	a = 5
	MVII #5,R0
	MVO R0,V1
	; 	b = 9
	MVII #9,R0
	MVO R0,V2
	; 	if not a = $fffa then poke $0200,$10f
	MVI V1,R0
	COMR R0
	CMPI #65530,R0
	BNE T1
	MVII #512,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T1:
	; 	if -a = $fffb then poke $0201,$10f
	MVI V1,R0
	NEGR R0
	CMPI #65531,R0
	BNE T3
	MVII #513,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T3:
	; 	if peek($0200) = $010f then poke $0202,$10f
	MVI 512,R0
	CMPI #271,R0
	BNE T5
	MVII #514,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T5:
	; 	if a+1=6 then poke $0203,$10f
	MVI V1,R0
	INCR R0
	CMPI #6,R0
	BNE T7
	MVII #515,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T7:
	; 	if a+b=14 then poke $0204,$10f
	MVI V1,R0
	ADD V2,R0
	CMPI #14,R0
	BNE T9
	MVII #516,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T9:
	; 	if a+(b+1)=15 then poke $0205,$10f
	MVI V2,R0
	INCR R0
	ADD V1,R0
	CMPI #15,R0
	BNE T11
	MVII #517,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T11:
	; 	if a-1=4 then poke $0206,$10f
	MVI V1,R0
	DECR R0
	CMPI #4,R0
	BNE T13
	MVII #518,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T13:
	; 	if a-b=$fffc then poke $0207,$10f
	MVI V1,R0
	SUB V2,R0
	CMPI #65532,R0
	BNE T15
	MVII #519,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T15:
	; 	if a-(b+1)=$fffb then poke $0208,$10f
	MVI V1,R0
	MVI V2,R1
	INCR R1
	SUBR R1,R0
	CMPI #65531,R0
	BNE T17
	MVII #520,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T17:
	; 	if (a or 2)=7 then poke $0209,$10f
	MVI V1,R0
	ANDI #65533,R0
	XORI #2,R0
	CMPI #7,R0
	BNE T19
	MVII #521,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T19:
	; 	if (a or b)=13 then poke $020a,$10f
	MVI V1,R0
	MVI V2,R4
	COMR R4
	ANDR R4,R0
	XOR V2,R0
	CMPI #13,R0
	BNE T21
	MVII #522,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T21:
	; 	if (a or (b+1))=15 then poke $020b,$10f
	MVI V1,R0
	MVI V2,R1
	INCR R1
	COMR R1
	ANDR R1,R0
	COMR R1
	XORR R1,R0
	CMPI #15,R0
	BNE T23
	MVII #523,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T23:
	; 	if (a xor 2)=7 then poke $020c,$10f
	MVI V1,R0
	XORI #2,R0
	CMPI #7,R0
	BNE T25
	MVII #524,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T25:
	; 	if (a xor b)=12 then poke $020d,$10f
	MVI V1,R0
	XOR V2,R0
	CMPI #12,R0
	BNE T27
	MVII #525,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T27:
	; 	if (a xor (b+1))=15 then poke $020e,$10f
	MVI V1,R0
	MVI V2,R1
	INCR R1
	XORR R1,R0
	CMPI #15,R0
	BNE T29
	MVII #526,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T29:
	; 	if (a and 1)=1 then poke $020f,$10f
	MVI V1,R0
	ANDI #1,R0
	CMPI #1,R0
	BNE T31
	MVII #527,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T31:
	; 	if (a and b)=1 then poke $0210,$10f
	MVI V1,R0
	AND V2,R0
	CMPI #1,R0
	BNE T33
	MVII #528,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T33:
	; 	if (a and (b+1))=0 then poke $0211,$10f
	MVI V1,R0
	MVI V2,R1
	INCR R1
	ANDR R1,R0
	CMPI #0,R0
	BNE T35
	MVII #529,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T35:
	; 	if a=5 then poke $0212,$10f
	MVI V1,R0
	CMPI #5,R0
	BNE T37
	MVII #530,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T37:
	; 	if a<>b then poke $0213,$10f
	MVI V1,R0
	CMP V2,R0
	BEQ T39
	MVII #531,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T39:
	; 	if a<b then poke $0214,$10f
	MVI V1,R0
	CMP V2,R0
	BGE T41
	MVII #532,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T41:
	; 	if a<=b then poke $0215,$10f
	MVI V1,R0
	CMP V2,R0
	BGT T43
	MVII #533,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T43:
	; 	if b>a then poke $0216,$10f
	MVI V2,R0
	CMP V1,R0
	BLE T45
	MVII #534,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T45:
	; 	if b>=a then poke $0217,$10f
	MVI V2,R0
	CMP V1,R0
	BLT T47
	MVII #535,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T47:
	; 	if a=4+1 then poke $0218,$10f
	MVI V1,R0
	CMPI #5,R0
	BNE T49
	MVII #536,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T49:
	; 	if a<>3-1 then poke $0219,$10f
	MVI V1,R0
	CMPI #2,R0
	BEQ T51
	MVII #537,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T51:
	; 	if a<8+1 then poke $021a,$10f
	MVI V1,R0
	CMPI #9,R0
	BGE T53
	MVII #538,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T53:
	; 	if a<=8+1 then poke $021b,$10f
	MVI V1,R0
	CMPI #9,R0
	BGT T55
	MVII #539,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T55:
	; 	if a>1-1 then poke $021c,$10f
	MVI V1,R0
	CMPI #0,R0
	BLE T57
	MVII #540,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T57:
	; 	if a>=1-1 then poke $021d,$10f 
	MVI V1,R0
	CMPI #0,R0
	BLT T59
	MVII #541,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T59:
	; 	if a*2=10 then poke $021e,$10f
	MVI V1,R0
	SLL R0,1
	CMPI #10,R0
	BNE T61
	MVII #542,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T61:
	; 	if a*4=20 then poke $021f,$10f
	MVI V1,R0
	SLL R0,2
	CMPI #20,R0
	BNE T63
	MVII #543,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T63:
	; 	if a*b=45 then poke $0220,$10f
	MVI V1,R0
	MVI V2,R4
	MOVR R0,R5
	CLRR R0
	TSTR R4
	BEQ T66
T67:
	ADDR R5,R0
	DECR R4
	BNE T67
T66:
	CMPI #45,R0
	BNE T65
	MVII #544,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T65:
	; 	if a*(b+1)=50 then poke $0221,$10f
	MVI V1,R0
	MVI V2,R1
	INCR R1
	MOVR R1,R4
	MOVR R0,R5
	CLRR R0
	TSTR R4
	BEQ T70
T71:
	ADDR R5,R0
	DECR R4
	BNE T71
T70:
	CMPI #50,R0
	BNE T69
	MVII #545,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T69:
	; 	if a/2=2 then poke $0222,$10f
	MVI V1,R0
	SAR R0,1
	CMPI #2,R0
	BNE T73
	MVII #546,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T73:
	; 	if a/4=1 then poke $0223,$10f
	MVI V1,R0
	SAR R0,2
	CMPI #1,R0
	BNE T75
	MVII #547,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T75:
	; 	if 20/a=4 then poke $0224,$10f
	MVII #20,R0
	MVI V1,R4
	MOVR R0,R5
	TSTR R4
	BEQ T78
	MVII #-1,R0
T79:
	INCR R0
	SUBR R4,R5
	BC T79
T78:
	CMPI #4,R0
	BNE T77
	MVII #548,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T77:
	; 	if b/a=1 then poke $0225,$10f
	MVI V2,R0
	MVI V1,R4
	MOVR R0,R5
	TSTR R4
	BEQ T82
	MVII #-1,R0
T83:
	INCR R0
	SUBR R4,R5
	BC T83
T82:
	CMPI #1,R0
	BNE T81
	MVII #549,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T81:
	; 	if a%2=1 then poke $0226,$10f
	MVI V1,R0
	ANDI #1,R0
	CMPI #1,R0
	BNE T85
	MVII #550,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T85:
	; 	if a%4=1 then poke $0227,$10f
	MVI V1,R0
	ANDI #3,R0
	CMPI #1,R0
	BNE T87
	MVII #551,R0
	PSHR R0
	MVII #271,R0
	PULR R4
	MVO@ R0,R4
T87:
	; 	for a=$28 to $ef step 3
	MVII #40,R0
	MVO R0,V1
T89:
	; 	poke $0200+a,$002f*8+7
	MVII #512,R0
	ADD V1,R0
	PSHR R0
	MVII #383,R0
	PULR R4
	MVO@ R0,R4
	; 	next a
	MVII #239,R0
	CMP V1,R0
	BLE T90
	MVI V1,R0
	ADDI #3,R0
	MVO R0,V1
	B T89
T90:
	; 	for a=$ef to $29 step -3
	MVII #239,R0
	MVO R0,V1
T91:
	; 	poke $0200+a,$0034*8+7
	MVII #512,R0
	ADD V1,R0
	PSHR R0
	MVII #423,R0
	PULR R4
	MVO@ R0,R4
	; 	next a
	MVII #41,R0
	CMP V1,R0
	BGE T92
	MVI V1,R0
	SUBI #3,R0
	MVO R0,V1
	B T91
T92:
	; 	for a=$2a to $ef step 3
	MVII #42,R0
	MVO R0,V1
T93:
	; 	poke $0200+a,$0027*8+7
	MVII #512,R0
	ADD V1,R0
	PSHR R0
	MVII #319,R0
	PULR R4
	MVO@ R0,R4
	; 	next a
	MVII #239,R0
	CMP V1,R0
	BLE T94
	MVI V1,R0
	ADDI #3,R0
	MVO R0,V1
	B T93
T94:
	; 	a = 5
	MVII #5,R0
	MVO R0,V1
	; 	b = 6
	MVII #6,R0
	MVO R0,V2
	; 	a = b
	MVI V2,R0
	MVO R0,V1
	; 	a = a + b
	MVI V1,R0
	ADD V2,R0
	MVO R0,V1
	; 	a = a + 5
	MVI V1,R0
	ADDI #5,R0
	MVO R0,V1
	; 	a = a + b + 5
	MVI V1,R0
	ADD V2,R0
	ADDI #5,R0
	MVO R0,V1
	; 	a = (a + b) + 3
	MVI V1,R0
	ADD V2,R0
	ADDI #3,R0
	MVO R0,V1
	; 	for a=1 to 5
	MVII #1,R0
	MVO R0,V1
T95:
	; 	b=b+1
	MVI V2,R0
	INCR R0
	MVO R0,V2
	; 	next a
	MVII #5,R0
	CMP V1,R0
	BLE T96
	MVI V1,R0
	INCR R0
	MVO R0,V1
	B T95
T96:
	; 
	; 	a = not a
	MVI V1,R0
	COMR R0
	MVO R0,V1
	; 	a = -a
	MVI V1,R0
	NEGR R0
	MVO R0,V1
	; 	a = a = b
	MVI V1,R0
	CMP V2,R0
	MVII #1,R0
	BEQ T97
	DECR R0
T97:
	MVO R0,V1
	; 	a = a <> b
	MVI V1,R0
	CMP V2,R0
	MVII #1,R0
	BNE T98
	DECR R0
T98:
	MVO R0,V1
	; 	a = a < b
	MVI V1,R0
	CMP V2,R0
	MVII #1,R0
	BLT T99
	DECR R0
T99:
	MVO R0,V1
	; 	a = a > b
	MVI V1,R0
	CMP V2,R0
	MVII #1,R0
	BGT T100
	DECR R0
T100:
	MVO R0,V1
	; 	a = a <= b
	MVI V1,R0
	CMP V2,R0
	MVII #1,R0
	BLE T101
	DECR R0
T101:
	MVO R0,V1
	; 	a = a >= b
	MVI V1,R0
	CMP V2,R0
	MVII #1,R0
	BGE T102
	DECR R0
T102:
	MVO R0,V1
	; 	if a=b then a=9 else a=11
	MVI V1,R0
	CMP V2,R0
	BNE T103
	MVII #9,R0
	MVO R0,V1
	B T105
T103:
	MVII #11,R0
	MVO R0,V1
T105:
	; 
	; 	restore table
	MVII #Q2,R4
	MVO R4,_read
	; loop:	read value
	; LOOP
Q3:		MVI _read,R4
	MVI@ R4,R0
	MVO R4,_read
	MVO R0,V3
	; 	if value=0 then goto end
	MVI V3,R0
	CMPI #0,R0
	BNE T106
	B Q4
T106:
	; 	poke value+512,95*8+7
	MVI V3,R0
	ADDI #512,R0
	PSHR R0
	MVII #767,R0
	PULR R4
	MVO@ R0,R4
	; 	goto loop
	B Q3
	; 
	; end:
	; END
Q4:	; 	goto end
	B Q4
	; 
	; table:
	; TABLE
Q2:	; 	data 5*20+7,5*20+8,5*20+9,5*20+10,5*20+11
	DECLE 107
	DECLE 108
	DECLE 109
	DECLE 110
	DECLE 111
	; 	data 6*20+7,6*20+11
	DECLE 127
	DECLE 131
	; 	data 7*20+7
	DECLE 147
	; 	data 7*20+11
	DECLE 151
	; 	data 8*20+7,8*20+8,8*20+9,8*20+10,8*20+11
	DECLE 167
	DECLE 168
	DECLE 169
	DECLE 170
	DECLE 171
	; 	data 0
	DECLE 0
	; 
	; sample: PROCEDURE
	; SAMPLE
Q7:	PROC
	BEGIN
	; 	asm NOP
 NOP
	; 	asm NOP	
 NOP	
	;         END
	RETURN
	ENDP
	; 
        ;
        ; Wait for interruption
        ;
_wait:  PROC
        CLRR    R0
        MVO     R0,_int         ; Clears waiting flag
@@1:    CMP     _int,  R0       ; Waits for change
        BEQ     @@1
        JR      R5              ; Returns
        ENDP

        ;
        ; Interruption routine
        ;
_int_vector:     PROC
        BEGIN

        MVO     R0,     $20     ; Activates display
        MVI     $21,    R0      ; Activates mode for 64 definitions of MOB
        MVII    #1,     R0
        MVO     R0,     _int    ; Indicates interrupt happened
        MVI _first_time,R0
        TSTR R0
        BEQ @@vi0
        DECR R0
        MVO R0,_first_time
        MVII    #0,     R0
        MVO     R0,     $28     ; Color stack 0
        MVO     R0,     $2A     ; Color stack 2
        MVO     R0,     $2C     ; Border color
@@vi0:
        ;
        ; Detect GRAM definition
        ;
        MVI _load_gram,R0
        TSTR R0
        BEQ @@vi1
        CLRR R0
        MVO R0,_load_gram
        MVI _gram_bitmap,R4
        MVI _gram_target,R1
        SLL R1,2
        SLL R1,1
        ADDI #$3800,R1
        MOVR R1,R5
        MVI _gram_total,R0
@@vi3:
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        DECR R0
        BNE @@vi3
@@vi1:
    MVI     $18,R0
    MVO     R0,_col0
    MVI     $19,R0
    MVO     R0,_col1
    MVI     $1A,R0
    MVO     R0,_col2
    MVI     $1B,R0
    MVO     R0,_col3
    MVI     $1C,R0
    MVO     R0,_col4
    MVI     $1D,R0
    MVO     R0,_col5
    MVI     $1E,R0
    MVO     R0,_col6
    MVI     $1F,R0
    MVO     R0,_col7
	MVII	#0,R0
	MVO 	R0,$18
	MVO 	R0,$19
    MVO     R0,$1A
    MVO     R0,$1B
    MVO     R0,$1C
    MVO     R0,$1D
	MVO 	R0,$1E
    MVO     R0,$1F
    
        ; Updates sprites (MOBs)
        MVII #_mobs,R4
        MVII #$0,R5     ; X-coordinates
        MVII #8,R1
@@vi2:  MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        DECR R1
        BNE @@vi2

        ; Random number generator
MACRO _ROR
	RRC R0,1
	MOVR R0,R1
	SLR R1,2
	SLR R1,2
	ANDI #$0800,R1
	SLR R1,2
	SLR R1,2
	ANDI #$007F,R0
	XORR R1,R0
ENDM
        MVI _rand,R0
        SETC
        _ROR
        XOR _frame,R0
        _ROR
        XOR _rand,R0
        _ROR
        XORI #9,R0
        MVO R0,_rand

        ; Increase frame number
        MVI _frame,R0
        INCR R0
        MVO R0,_frame

        RETURN
        ENDP
    
        ORG $330,$330,"-RWB"
_frame:     RMB 1
_read:      RMB 1  
_gram_bitmap:   RMB 1
_screen:    RMB 1
_color:     RMB 1
_mobs:      RMB 3*8
_col0:      RMB 1
_col1:      RMB 1
_col2:      RMB 1
_col3:      RMB 1
_col4:      RMB 1
_col5:      RMB 1
_col6:      RMB 1
_col7:      RMB 1

SCRATCH:    ORG $100,$100,"-RWBN"
ISRVEC:     RMB 2
_int:       RMB 1
_rand:      RMB 1
_load_gram: RMB 1
_gram_target:   RMB 1
_gram_total:    RMB 1
_first_time:    RMB 1
V1:	RMB 1	; A
V2:	RMB 1	; B
V3:	RMB 1	; VALUE
_SCRATCH:	EQU $

SYSTEM:	ORG $2F0, $2F0, "-RWBN"
STACK:	RMB 32
_SYSTEM:	EQU $
